<?php
include "inc.php";
// we will do our own error handling
#error_reporting(0);
#error_prepend_string("<p>error = 'Error'</p>");
#$old_error_handler = set_error_handler("error_handler");
$lang="";
$spellercss = '../html/spellerStyle.css';
$word_win_src = '../html/wordWindow.js';
if(!empty($_POST['textinputs'])){
	$textinputs = $_POST['textinputs']; # array	
}else{
	$textinputs = array();
}
$cstRelativeDictPathUs = '../dic/dict-us.txt';
# set the JavaScript variable to the submitted text.
# textinputs is an array, each element corresponding to the (url-encoded)
# value of the text control submitted for spell-checking
function print_textinputs_var() {
    global $textinputs;
    foreach( $textinputs as $key=>$val ) {
        echo "textinputs[$key] = '".addslashes($val)."';\n";
    }
}

function print_mis(){
global $idWord;
    if($idWord){
        foreach( $idWord as $key=>$val ) {
            echo "idWord[$key] = '$val';\n";
        }
    }
}

# make declarations for the text input index
function print_textindex_decl( $text_input_idx ) {
    echo "words[$text_input_idx] = [];\n";
    echo "suggs[$text_input_idx] = [];\n";
}

# set an element of the JavaScript 'words' array to a misspelled word
function print_words_elem( $word, $index, $text_input_idx ) {
    echo "words[$text_input_idx][$index] = '" . addslashes( $word ) . "';\n";
}


# set an element of the JavaScript 'suggs' array to a list of suggestions
function print_suggs_elem( $suggs, $index, $text_input_idx ) {
    echo "suggs[$text_input_idx][$index] = [";
    foreach( $suggs as $key=>$val ) {
        if( $val ) {
            echo "'" . addslashes( $val ) . "'";
            if ( $key+1 < count( $suggs )) {
                echo ", ";
            }
        }
    }
    echo "];\n";
}

# escape single quote
function escape_quote( $str ) {
    return preg_replace ( "/'/", "\\'", $str );
}


# handle a server-side error.
function error_handler( $err ) {
    echo "error = '" . addslashes( $err ) . "';\n";
}



# load dictionary
function LoadDictArrayRu(){

}

function LoadDictArrayUs(){
    global $cstRelativeDictPathUs;
      $DictSoundex=array();
	$f=fopen($cstRelativeDictPathUs,'r');
	while(!feof($f))
    {   $s=fgets($f,4096);
        $l=preg_split('/:/',rtrim($s));
        if(!isset($l[1])) {dd($l);die;}
//        $DictSoundex[$l[0]]=preg_split('/ /',$l[1]);
        $DictSoundex[$l[0]]=$l[1];//preg_split('/ /',$l[1]);
    };
	fclose($f);

   foreach(array('DictSoundex') as $v)
   $GLOBALS[$v]=$$v;

}

Function LangCheng($chrWord){

    if(ord($chrWord)<65){
        $valRet=False;
    }elseif(ord($chrWord)>64 && ord($chrWord)<123){
        $valRet=True;
    }else{
        $valRet=False;
    }

    return $valRet; 
}


function SpellCheck($strWord){
 $WordS=strtolower($strWord);
 $sx=SoundexCh($WordS);
 $ret=False;
// if(isset($GLOBALS['DictSoundex'][SoundexCh($WordS)])){
//    foreach($GLOBALS['DictSoundex'][SoundexCh($WordS)] as $v5){
//    if($v5==$WordS) $ret=True;
//    }
// }else{
// $ret=False;
// }
  
  if(isset($GLOBALS['DictSoundex'][$sx])){
  	$s=$GLOBALS['DictSoundex'][$sx];
  	if(strstr(" $s "," $WordS "))
  		return true;
  }else{
  	return false;
  }

 return $ret;
}



#requires lowcase
function SoundexCh($strString){

    if(!$strString) return '';  
    static $trx;
    if(!isset($trx)){
        $trx=array('p'=>1,'b'=>1,'f'=>2,'v'=>2,'c'=>3,'k'=>3,
            's'=>3,'g'=>4,'j'=>4,'q'=>5,'x'=>5, 'z'=>5,'d'=>6,'t'=>6,'l'=>7,
            'm'=>8,'n'=>8,'r'=>9);
    };

    $Soundex = strtoupper($strString[0]);
    $prevCode='';
    for ($i = 1,$ci=strlen($strString); $i<$ci;$i++){
        $l=$strString[$i];
        $strCode = &$trx[$l]; 
        if (isset($strCode) and ($strCode!=$prevCode) ){
            $Soundex.=$strCode;
            $prevCode=$strCode;
        }
    }
  return ($Soundex);  
}


function WordSimilarity($strWord, $strSimilarWord){
    $strWord=strtolower($strWord);
    $strSimilarWord=strtolower($strSimilarWord);
    $intWordLen = strlen($strWord);
    $intSimilarWordLen = strlen($strSimilarWord);

    $intMaxBonus = 3;
    $intPerfectValue = $intWordLen + $intWordLen + $intMaxBonus;
    $intSimilarity = $intMaxBonus - abs($intWordLen - $intSimilarWordLen);

    for ($i = 0; $i< $intWordLen; $i++){
        if ($i <= $intSimilarWordLen){
            if (substr($strWord, $i, 1) == substr($strSimilarWord, $i, 1)){
                $intSimilarity = $intSimilarity + 1;
            }

            if ((substr($strWord, $intWordLen - $i + 1, 1)) == (substr($strSimilarWord, $intSimilarWordLen - $i + 1, 1))){
                $intSimilarity = $intSimilarity + 1;
            }
        }
    }
    return $intSimilarity / $intPerfectValue;
    
}


function Suggest($strWord){

$strSuggestionArray=array();
$dblSimilarityArray=array();
    $strSuggestions="";
    $intMaxSuggestions = 10;
    $strSoundexCh = SoundexCh($strWord);
    if(isset($GLOBALS['DictSoundex'][$strSoundexCh])){
        $Suggestt=preg_split('/ /',$GLOBALS['DictSoundex'][$strSoundexCh]);
    }else{
    $Suggestt=array();
    }

    $intSuggestionCount = (count($Suggestt) < $intMaxSuggestions)?count($Suggestt) : $intMaxSuggestions - 1;

    
    $strSuggestionArray=array_pad($strSuggestionArray, $intSuggestionCount, "");
    $dblSimilarityArray=array_pad($dblSimilarityArray, $intSuggestionCount, "");

    if(count($Suggestt)!=0){
    foreach($Suggestt as $strSuggestion){
        $dblSimilarity = WordSimilarity($strWord, $strSuggestion);
        $i = $intSuggestionCount;
        do {
            if ($i < $intSuggestionCount){
                $strSuggestionArray[$i + 1] = $strSuggestionArray[$i];
                $dblSimilarityArray[$i + 1] = $dblSimilarityArray[$i];
            }
            $strSuggestionArray[$i] = $strSuggestion;
            $dblSimilarityArray[$i] = $dblSimilarity;
            $i--;
            if ($i == -1){
                break;
            }
        }while ($dblSimilarity > $dblSimilarityArray[$i]);
    }
    }else{
    $strSuggestionArray=array();
    }

    if(count($strSuggestionArray)==0){
        $strLiner=str_pad("#,", strlen($strWord)+2,$strWord);
    }else{
        $gh=implode("^",$strSuggestionArray);
        $strLiner=str_pad("&,", strlen($strWord)+2,$strWord);
        $strLiner=str_pad($strLiner, strlen($strLiner)+1,",");
        $strLiner=str_pad($strLiner, strlen($strLiner)+strlen($gh),$gh);
        if(substr($strLiner,-1)==" "){
        $strLiner=substr($strLiner,0,strlen($strLiner)-1);
        }
    }
    return $strLiner;
}

## get the list of misspelled words. Put the results in the javascript words array
## for each misspelled word, get suggestions and put in the javascript suggs array
function print_checker_results() {

        global $textinputs;
        global $aspellret;
        global $idWord;
        global $idx;

    LoadDictArrayUs();  
    if(!$GLOBALS['DictSoundex'])
        error_handler("NoDicFileF"); //No Dictionary file found");
        //print "alert('No Dictionary file found');\n";


    $tempVal[0]="";
    $idx=0; 
    $g=0;
    for ($r=0,$ci=sizeof($textinputs); $r<$ci; $r++){
        if(LangCheng(substr($textinputs[$r], 0, 1))){
            if(SpellCheck($textinputs[$r])){
         
            }else{ 
            $tempVal[$g]='*';
            $g++;
            $tempVal[$g]=Suggest($textinputs[$r]);
            $g++;
            $idWord[$idx]=$r;
            $idx++;
            }
        }else{
         
        }
    }


    $aspellret=implode("\n",$tempVal);
        # exec aspell command

            $linesout=explode( "\n", $aspellret );
                $index = 0;
                $text_input_index = -1;
                # parse each line of aspell return
                foreach( $linesout as $key=>$val ) {
                    $chardesc = substr( $val, 0, 1 );
                    # if '&', then not in dictionary but has suggestions
                    # if '#', then not in dictionary and no suggestions
                    # if '*', then it is a delimiter between text inputs
                    if( $chardesc == '&' || $chardesc == '#' ) {
                        $line = explode( ",", $val,5);
                        print_words_elem( $line[1], $index, $text_input_index );
                        if( isset( $line[2] )) {
                            $suggs = explode( "^", $line[2] );
                        } else {
                            $suggs = array();
                        }
                        print_suggs_elem( $suggs, $index, $text_input_index );
                        $index++;
                    } elseif( $chardesc == '*' ) {
                        $text_input_index++;
                        print_textindex_decl( $text_input_index );
                        $index = 0;
                    }
                }
                
}


if(!function_exists('file_get_contents')):
function file_get_contents($fname)
{
   $f=fopen($fname,"rb");
   $res=fread($f,filesize($fname));
   fclose($f);
   return $res;
}
endif;

?>
<HTML id="Spell Checker">
	<HEAD>
		<TITLE>Spell Check</TITLE>
		<META http-equiv="Content-Type" content="text/html; charset=windows-1251">
		<STYLE>
.text {PADDING-RIGHT: 0px; PADDING-LEFT: 0px; PADDING-BOTTOM: 1px; FONT: 8pt/8pt Tahoma; PADDING-TOP: 0px}
.Button,.bt2Up,.bt2Down,.bt2Over,.bt2Out {cursor:hand;padding:0px 0px 0px 0px; font-size: 10px; height: 20px;width:80px;}
.Button {margin:'1px 1px 1px 1px';border:'1px solid #CCCCCC';background:'#EEEEEE'}
.bt2Up   {margin:'1px 1px 1px 1px';border:'1px solid #0A246A';background:'#B6BDD2'}
.bt2Down {margin:'2px 0px 0px 2px';border:'1px solid #0A246A';background:'#8592B5'}
.bt2Over {margin:'1px 1px 1px 1px';border:'1px solid #0A246A';background:'#B6BDD2'}
.bt2Out  {margin:'1px 1px 1px 1px';border:'1px solid #CCCCCC';background:'#EEEEEE'}
</STYLE>
	</HEAD>
	<SCRIPT Language="JScript" TYPE="text/JScript.Encode" Src="../html/inc.js"></SCRIPT>
	<SCRIPT Language="JScript" TYPE="text/JScript.Encode" Src="../html/spell.js"></SCRIPT>
<script>
function ignore_word() {
	ignoreWords();
}

function ignore_all() {
		ignoreAlls();
}

function replace_word() {
		replaceWords();
}

function replace_all() {
		replaceAlls();
}

function end_spell() {
		terminateSpells();
}

function undo() {
	if( spellerObject ) {
		spellerObject.undo();
	}
}

function suggText() {
		setSuggestedText();
}

function init_spell() {
init_spells();
}

var suggs = new Array();
var words = new Array();
var textinputs = new Array();
var idWord = new Array();
var error;

<?php

print_checker_results();
print_mis();
?>

</script>
<body  onLoad="init_spell();" bgcolor="#EEEEEE">
		<form name="spellcheck" enctype="application/x-www-form-urlencoded">
			<table border="0" cellpadding="0" cellspacing="0" id="TABLE2" height="200">
				<tr>
					<td colspan="3" class="text">
					<script language="JavaScript">document.write(JMessage("NotInDic"));</script> 
					</td>
				</tr>
				<tr>
					<td colspan="3">
						<INPUT style='background-color:DADADA;color:000000;font-size:8pt;width:300px;' id="misword" readOnly type="text" size="43" name="misword"></td>
				</tr>
				<TR>
					<td colspan="3" height="10"></td>
				</TR>
				<tr>
					<td class="text" width="161">
					<script language="JavaScript">document.write(JMessage("ChengTo"));</script>
					</td>
				</tr>
				<tr valign="top">
					<td width="161" height="139">
						<TABLE id="Table3" height="151" cellSpacing="0" cellPadding="0" border="0">
							<TR>
								<TD style='font-size:8pt;'>
									<INPUT style='font-size:8pt;width: 200px;' id="txtsugg" type="text" name="txtsugg">
								</TD>
							</TR>
							<TR>
								<TD><SELECT style='width:200px;margin-top:2;font-size:8pt;' id="sugg" ondblclick="replace_word();" onchange="suggText();" size="7" name="sugg">
										<OPTION></OPTION>
									</SELECT>
								</TD>
							</TR>
						</TABLE>
					</td>
					<td colSpan="2" height="139">
						<TABLE id="Table1" height="146" cellSpacing="0" cellPadding="0" border="0">
							<TR>
								<TD colSpan="3"><center>
								<script language="JavaScript">document.write('<input type=button value="'+JMessage("IgnoreWord")+'" class=Button onmouseover="this.className=\'bt2Over\'" onmouseout="this.className=\'bt2Out\'" onclick="this.className=\'bt2Down\'; ignore_word();">');</script>
								</center>
								</TD>
							</TR>
							<TR>
								<TD colSpan="3" height="5"><center>
								<script language="JavaScript">document.write('<input type=button value="'+JMessage("IgnoreAll")+'" class=Button onmouseover="this.className=\'bt2Over\'" onmouseout="this.className=\'bt2Out\'" onclick="this.className=\'bt2Down\'; ignore_all();">');</script>
									</center></TD>
							</TR>
							<TR>
								<TD colSpan="3"></TD>
							</TR>
							<TR>
								<TD colSpan="3" height="4"><center>
								<script language="JavaScript">document.write('<input type=button value="'+JMessage("Replace")+'" class=Button onmouseover="this.className=\'bt2Over\'" onmouseout="this.className=\'bt2Out\'" onclick="this.className=\'bt2Down\'; replace_word();">');</script>
								</center>
								</td>
							</TR>
							<TR>
								<TD colSpan="3"><center>
								<script language="JavaScript">document.write('<input type=button value="'+JMessage("ReplaceAll")+'" class=Button onmouseover="this.className=\'bt2Over\'" onmouseout="this.className=\'bt2Out\'" onclick="this.className=\'bt2Down\'; replace_all();">');</script>
								</center>
								</TD>
							</TR>
							<TR>
								<TD colSpan="3"></TD>
							</TR>
							<TR>
								<TD colSpan="3"><center>
								<script language="JavaScript">document.write('<input type=button value="'+JMessage("Close")+'" class=Button onmouseover="this.className=\'bt2Over\'" onmouseout="this.className=\'bt2Out\'" onclick="this.className=\'bt2Down\'; end_spell();">');</script>
									</center></TD>
							</TR>
						</TABLE>
					</td>
				</tr>
			</table>
		</form>
	</body>
</html>






