
var noSuggestionSelection = fMessage("nosuggestions");//"- No suggestions -";

//alert(oPar[0].word);
function selectDefaultSuggestion() {
	var slct = document.getElementById('sugg');
	var txt = document.getElementById('txtsugg');
	if( slct.options.length == 0 ) {
		addSuggestion( noSuggestionSelection );
	} else {
		slct.options[0].selected = true;
	}
	setSuggestedText();
}

function addSuggestion( sugg_text ) {
	var slct = document.getElementById('sugg');
	if( sugg_text ) {
		var i = slct.options.length;
		var newOption = new Option( sugg_text, 'sugg_text'+i );
		slct.options[i] = newOption;
	 }
}

function resetForm() {
	if( this._form ) {
		this._form.reset();
	}
}

function clearSuggestions() {
	var slct = document.getElementById('sugg');
	for( var j = slct.length - 1; j > -1; j-- ) {
		if( slct.options[j] ) {
			slct.options[j] = null;
		}
	}
}

function setSuggestedText() {
	var slct = document.getElementById('sugg');
	var txt = document.getElementById('txtsugg');
	var str = "";
	if( (slct.options[0].text) && slct.options[0].text != noSuggestionSelection ) {
		str = slct.options[slct.selectedIndex].text;
	}
	txt.value = str;
}


var arrWord=new Array();
var idword=0;
var oPar;

function oWord(pos, wrd, node){
    this.id = pos;
    this.word = wrd;
    this.node = node;
    this.stat = '';
}

function init_spells() {
oPar=opener.Dialog._arguments;
//alert(oPar.arr[0].word);
	if(this.error) alert(this.error);
	for(var i=0; i<this.idWord.length; i++){
		arrWord[i]=new oWord(oPar.arr[this.idWord[i]].id, oPar.arr[this.idWord[i]].word, oPar.arr[this.idWord[i]].node, oPar.arr[this.idWord[i]].stat );	
	}
    spellcheck(idword);
    
    return true;
}

function ignoreWords() {

    if( !document.getElementById('misword').value) {
        alert( 'Error: '+ fMessage("notindictionarytextismissing"));
        return false;
    }
    // set as ignored
    
    arrWord[idword].stat="I";
        idword++;
        ignword++;
        spellcheck();
   
}

function ignoreAlls() {
    
    if( !document.getElementById('misword').value) {
        alert( 'Error: '+ fMessage("notindictionarytextismissing"));
        return false;
    }


    // loop through all the words after this word
    for( var i = idword; i < arrWord.length; i++ ) {
        if(arrWord[i].word==arrWord[idword].word && (arrWord[i].stat!='R' || arrWord[i].stat!='I')){
           arrWord[i].stat='I'; 
			ignword++;
        }
    }

    // finally, move on
    idword++;
    spellcheck();
}

function fReplaseWord(wrd){
	var tmp, id;
	tmp=arrWord[idword].node.data.match(arrWord[idword].word);
	if(tmp.index==arrWord[idword].id) id=arrWord[idword].id;
	if(tmp.index>arrWord[idword].id) id=tmp.index;
	arrWord[idword].node.replaceData(id,arrWord[idword].word.length,wrd);
}

function replaceWords() {
   
if( !document.getElementById('misword').value) {
        alert( 'Error: '+ fMessage("notindictionarytextismissing"));
        return false;
    }
    if( !document.getElementById('txtsugg').value ) {
        return;
    }
    var txt = document.getElementById('txtsugg');
    if( txt.value ) {
        var newspell = new String( txt.value );
       // MarkWord(ti);
        
       fMarkWord(idword);
        fReplaseWord(newspell);
            arrWord[idword].stat='R';
            idword++;
            repword++;
            spellcheck();
        
    }
}

function replaceAlls() {
if( !document.getElementById('misword').value) {
        alert( 'Error: '+ fMessage("notindictionarytextismissing"));
        return false;
    }
    if( !document.getElementById('txtsugg').value ) {
        return;
    }
    
    var txt = document.getElementById('txtsugg');
    if( !txt.value ) return;
    var newspell = new String( txt.value );

    // set this word as a "replace all" word. 
    fMarkWord(idword);

    // loop through all the words after this word
    for( var i = idword; i < arrWord.length; i++ ) {
            if(arrWord[i].word==arrWord[idword].word && (arrWord[i].stat!='R' || arrWord[i].stat!='I')){
           fMarkWord(i);
        fReplaseWord(newspell);
			arrWord[i].word=arrWord[idword].word;
            arrWord[i].stat='R';
            repword++;
        }
    }
    
    // finally, move on
    idword++;
    spellcheck();
}

function terminateSpells() {
    // called when we have reached the end of the spell checking.
    var msg = fMessage("spellcheckingiscompleted"); //"Spell checking is completed:\n\n";
    var numrepl = repword;
    if(idword==0 && arrWord.length==0) {
            //msg = "";
            msg =msg+ fMessage("nomisspellingsfound"); //"No misspellings found.";
    }
    if( numrepl == 0 && arrWord.length!=0) {
            msg=msg+fMessage("nowordswerechanged"); //"No words were changed.";  
    } else if( numrepl == 1 && arrWord.length!=0) {
        msg =msg+fMessage("onewordwaschanged");
    } else if( numrepl > 1 && arrWord.length!=0){
        msg =msg+numrepl + fMessage("wordswerechanged");//" words were changed.";
    }
    
    if( msg ) {
        msg =msg+ "\n"; //"\n";
        alert( msg );
    }

    // return back to the calling window
    window.close();
    return true;
}
var foo=opener.foo;
var repword=0;
var ignword=0;

function fMarkWord(nom){
	var range=oPar.doc.createRange();
	var tmp, id;
	var sel = oPar.seln;
	
	sel.removeAllRanges();
	tmp=arrWord[idword].node.data.match(arrWord[idword].word);
	if(tmp.index==arrWord[idword].id) id=arrWord[idword].id;
	if(tmp.index>arrWord[idword].id) id=tmp.index;
	if(tmp.index<arrWord[idword].id) id=tmp.index;
	
	range.setStart(arrWord[idword].node,id);
	range.setEnd(arrWord[idword].node,id+arrWord[idword].word.length); 
		
		
		sel.removeAllRanges();
		sel.addRange(range);	
	}


function spellcheck() {
//alert(arrWord.length+'|'+idword);
if(idword==arrWord.length || idword>arrWord.length){
	terminateSpells();
	return true;
}
if(arrWord[idword].stat=='I' || arrWord[idword].stat=='R'){
	idword++;
	spellcheck();
}
document.getElementById('misword').value=arrWord[idword].word;
fMarkWord(idword);
           _getSuggestions(idword);
}

function _getSuggestions(idword) {
    clearSuggestions();
    // add suggestion in list for each suggested word.
    // get the array of suggested words out of the
    // three-dimensional array containing all suggestions.
    var a_suggests = this.suggs[idword][0];  
    if( a_suggests ) {
        // got an array of suggestions.
        for( var ii = 0; ii < a_suggests.length; ii++ ) {   
            addSuggestion( a_suggests[ii] );
        }
    }
    selectDefaultSuggestion();
}
